/*
 * Copyright (C) 2006 TopCoder Inc., All Rights Reserved.
 */
package com.topcoder.web.ui.tag.breadcrumbtrail;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import javax.servlet.jsp.tagext.VariableInfo;


/**
 * Unit tests for BreadCrumbTrailTagExtraInfo implementation.
 *
 * @author TCSDEVELOPER
 * @version 2.0
 */
public class BreadCrumbTrailTagExtraInfoTest extends TestCase {
    /**
     * Creates a test suite for the tests in this test case.
     *
     * @return a TestSuite for this test case
     */
    public static Test suite() {
        TestSuite suite = new TestSuite(BreadCrumbTrailTagExtraInfoTest.class);

        return suite;
    }

    /**
     * Tests accessibility of constructor.
     */
    public void testConstructor() {
        new BreadCrumbTrailTagExtraInfo();
    }

    /**
     * Test of getVariableInfo method. Verifies if an array of length 2 is returned, consisting of
     * BREADCRUMB_FORMAT_NODE variable of type BreadCrumbNode and BREADCRUMB_FORMAT_STYLE_CLASS variable of type
     * String.
     */
    public void testGetVariableInfo() {
        BreadCrumbTrailTagExtraInfo tei = new BreadCrumbTrailTagExtraInfo();
        VariableInfo[] vi = tei.getVariableInfo(null);

        assertEquals("Returns an incorrect VariableInfo", 2, vi.length);
        assertEquals("Fails to set BREADCRUMB_FORMAT_NODE", BreadCrumbTrailTag.BREADCRUMB_FORMAT_NODE,
            vi[0].getVarName());
        assertEquals("Fails to set BREADCRUMB_FORMAT_NODE", BreadCrumbNode.class.getName(), vi[0].getClassName());
        assertEquals("Fails to set BREADCRUMB_FORMAT_STYLE_CLASS", BreadCrumbTrailTag.BREADCRUMB_FORMAT_STYLE_CLASS,
            vi[1].getVarName());
        assertEquals("Fails to set BREADCRUMB_FORMAT_STYLE_CLASS", String.class.getName(), vi[1].getClassName());
    }
}
