/*
 * Copyright (C) 2006 TopCoder Inc., All Rights Reserved.
 */
package com.topcoder.web.ui.tag.breadcrumbtrail;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;


/**
 * Unit tests for BreadCrumbException implementation.
 *
 * @author TCSDEVELOPER
 * @version 2.0
 */
public class BreadCrumbExceptionTest extends TestCase {
    /**
     * Creates a test suite for the tests in this test case.
     *
     * @return a TestSuite for this test case
     */
    public static Test suite() {
        TestSuite suite = new TestSuite(BreadCrumbExceptionTest.class);

        return suite;
    }

    /**
     * Test of constructor with one argument. Verifies it by getting the message being set.
     */
    public void testConstructor_OneArg() {
        String message = "message";
        BreadCrumbException exception = new BreadCrumbException(message);

        assertEquals("Fails to set message", message, exception.getMessage());
    }

    /**
     * Test of constructor with two arguments. Verifies it by getting the null cause back.
     */
    public void testConstructor_TwoArg() {
        BreadCrumbException exception = new BreadCrumbException("message", null);

        assertNull("Fails to set cause", exception.getCause());
    }
}
